;;
;; environment.scm
;;
;; Process environment helpers.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit environment))

(module
 environment
 (
  edit-file
  )

 (import scheme
	 (chicken base)
	 (chicken process-context)
	 (chicken process)
	 ansi)

 ;; Starts an editor on given file
 (define (edit-file file-path)
   (print "Editing...")
   (let* ((edvar (get-environment-variable "EDITOR"))
	  (editor (or edvar "editor"))
	  (pid (process-run editor (list file-path))))
     (let-values (((a b c) (process-wait pid)))
       (clrscr)
       (flush-output))))

 )
